
/* global Curve, Chart, Graph, THREE, pi */

// 
// agelis dimitrios 2018  


"use strict";

function log(st) {
    console.log(st)
}
var evn = 0;
var frames = 0;
function click() {
    alert("click");
}
function clickdown(event) {
    alert(event.target.id);
}

function clickhelp() {
    hideelement(getelement("help"));
}
setbackcolor(getelement("body"), "black");
var gf = new GF();
var sm = gf.getmanager();
var ttcolor = "pink";
var appw = sm.width;
var apph = sm.height;
var logw = appw;
var logh = apph;
sm.adddebug(); /// here because form


sm.dwin.drawoutline = true;
sm.dwin.x = 800;
sm.setbackcolor(0, 0, 0);
sm.drawbackground = false; //true; /// dont draw background if have a 2d or 3d app


var scene0 = sm.createscene(); ///  0



scene0.userevent = function (e, type) {
    evn++;
    if (type === "MU") {
    }
//info.title=concat(e.target,evn);
}

////  app 

var appname = "        'Ενταση ήχων"
var po;  //pressed object
var helptext = "Μελέτησε τις πληροφορίες για την ένταση του ήχου και δοκίμασε τις γνώσεις σου.";
var gui = scene0.addform(-1, "", 0, 0, appw, apph);

gui.drawbackground = false;
gui.pickable = false;


var form0 = gui.addform(-2, "", 0, 48, appw, apph - 48);
form0.backcolor = "white";

///var im1 = sm.createimage("images/9.png")
var im = [];
////// quiz
///// quiz data  needs im=[] for imageres indices

var ob1 = {q: "Το ανθρώπινο αυτί αντιλαμβάνεται ήχους που έχουν ένταση μεγαλύτερη από:",
    a: ["20 picoWatt / m²", "0.2 picoWatt / m²", "1 picoWatt / m²", "120 picoWatt / m²"],
    c: [0, 0, 1, 0]
}
var ob2 = {q: "Αν διπλασιασθεί η μεταβολή πίεσης ηχητικού κύματος τότε θα διπλασιασθεί και η έντασή του.",
    a: ["Σωστό", "Λάθος"],
    c: [0, 1]
}

var ob3 = {q: "Το αυτί μας αντιλαμβάνεται τον ήχο μιας γραφομηχανής. Για να αντιληφθεί ήχο διπλάσιας έντασης θα πρέπει να δουλέψουν ταυτόχρονα:",
    a: ["2 γραφομηχανές", "10 γραφομηχανές", "20 γραφομηχανές", "100 γραφομηχανές"],
    c: [0, 1, 0, 0]
}
var ob4 = {q: "Όταν ένας ήχος έχει 100 φορές μεγαλύτερη ένταση από έναν άλλον τότε η διαφορά τους είναι:",
    a: ["2db", "10db", "20db", "100db"],
    c: [0, 0, 1, 0]
}

var ob5 = {q: "Να κάνεις κλικ στους ήχους που έχουν ένταση μεγαλύτερη από 80db",
    a: ["κουδουνι", "ππροαύλιο", "δασος", "δρομος"],
    c: [1, 0, 0, 1]
}
var ob6 = {q: "Αποτελέσματα",
    a: ["Βαθμός", "Σωστές Απαντήσεις", "Ποσοστό Επιτυχίας"],
    c: [0, 0, 0]
}

var obquiz = {
    obar: [ob1, ob2, ob3, ob4, ob5, ob6],
    qtotal: 0,
    qright: 0,
    qpercent: 0,
    qanswered: 0,
    fparent: undefined
}

function resetquiz(obquiz) {
    var obar = obquiz.obar;
    var flist = obquiz.flist
    var i;
    for (i = 0; i < obar.length; i++) {
        obar[i].checked = 0; /// 0 no check  1  correct  2 wrong 
    }
    // unselect lists;

    for (i = 0; i < flist.childs.length; i++) {
        flist.childs[i].visible = false;
        var ali = flist.childs[i].childs[1]
        ali.uncheckchilds(); /// 0 no check  1  correct  2 wrong 
    }
    flist.childs[0].visible = true;

}
//// end q d

function makequizform(aform0, obquiz) {

/// fparent is form 0 
    var fparent = aform0.addform(0, "", 0, 0, aform0.width, aform0.height)
    obquiz.fparent = fparent;
    var i, ob;
    var obar = obquiz.obar
    var qf = [];
    var x1 = 500;

    var flist = fparent.addform(-1, "", 8, 8, fparent.width - 16, fparent.height - 80)
    obquiz.flist = flist;
    flist.backcolor = "#F0F8FF"
    var btn1 = fparent.addbutton(-2, "Προηγούμενη", x1, fparent.height - 60, 128, 50)
    var btn2 = fparent.addbutton(-3, "Επόμενη", x1 + 150, fparent.height - 60, 128, 50)
    var btn3 = fparent.addbutton(-4, "Απάντηση", x1 + 2 * 150, fparent.height - 60, 128, 50)
    var btn4 = fparent.addbutton(-5, "Επιστροφή", 8, fparent.height - 60, 128, 50)
    btn3.visible = false;
    btn4.onclick = function () {
        fparent.visible = false;
        resetquiz(obquiz)

    }
    btn1.onclick = function () {
        flist.showprevious()

    }

    btn2.onclick = function () {
        flist.shownext()

    }


    for (i = 0; i < obar.length; i++) {
        qf[i] = flist.addform(-1 - i, "", 8, 8, flist.width - 16, flist.height - 16)
        qf[i].backcolor = "white"
        ob = obar[i]
        ob.checked = 0;
        qf[i].addlabel(-1, ob.q, 8, 8, qf[i].width / 2, 364);   /// child[0]
        qf[i].childs[0].wrap = true;
        qf[i].childs[0].texth = 22;
        var li = qf[i].addlist(201 + i, "", 8, 148, 312, ob.a.length * 40); ///child[1]
        li.backcolor = "#F0F8FF"
        qf[i].addlabel(201 + i, "label" + 201 + i, 8, 148 + 200, 312, 40); ///child[2]
        qf[i].myqob = ob;  ///// has quiz object

        if (i === obar.length - 2) {
            li.multiselect = true
            li.backout(false)
            li.addlistitems(ob.a, [im[1], im[3], im[4], im[2]])
            li.subkind = "si"
            li.setchilds(8, 8, 250, 0, 160, 99)
            var j;
            for (j=0;j<li.childs.length;j++){
                li.childs[j].drawoutline=true;
                li.childs[j].linecolor=rgb(244,233,244);
            }

        } else {
            li.addlistitems(ob.a)
        }
    }
    
    qf[i - 1].childs[1].visible = false;
    qf[i - 1].id = "results";
    qf[i - 1].addlabel(-1, "Αποτελέσματα", 8, 100, 400, 32)
    qf[i - 1].addlabel(-1, "Αποτελέσματα2", 8, 100 + 40, 400, 32)
    qf[i - 1].addlabel(-1, "Αποτελέσματα3", 8, 100 + 2 * 40, 400, 32)

    qf[i - 1].childs[3].textcentered = false;
    qf[i - 1].childs[4].textcentered = false;
    qf[i - 1].childs[5].textcentered = false;

    flist.userdraw = function (ctx) {
        var frm = flist.getvisiblechild()
        var li = frm.childs[1]// 
        var resar = li.getselectedchilds()
        frm.childs[2].visible = frm.myqob.checked !== 0;
        if (frm.myqob.checked === 1) {
            frm.childs[2].title = "Απάντησες Σωστά";
            frm.childs[2].backcolor = "LawnGreen";
        }

        if (frm.myqob.checked === 2) {
            frm.childs[2].title = "Απάντησες Λάθος";
            frm.childs[2].backcolor = "pink";
        }

        li.pickable = frm.myqob.checked === 0;
        btn3.visible = (resar.length > 0 && frm.myqob.checked === 0)

        if (frm.id === "results") {
            obquiz.qtotal = obar.length - 1;

            obquiz.qright = 0;
            obquiz.qpercent = 0;
            obquiz.qanswered = 0;
            for (i = 0; i < obquiz.qtotal; i++) {
                var qob = flist.childs[i].myqob;
                if (qob.checked === 1) {
                    obquiz.qright++;
                    obquiz.qanswered++
                }
                if (qob.checked === 2) {
                    obquiz.qanswered++
                }

            }
            //// print results
            frm.childs[3].title = "Σωστές Απαντήσεις: " + obquiz.qright
            frm.childs[4].title = "Σύνολο Ερωτήσεων: " + obquiz.qtotal
            if (obquiz.qanswered < obquiz.qtotal) {
                var r1 = obquiz.qtotal - obquiz.qanswered;
                frm.childs[5].title = "Δεν έχεις απαντήσει σε " + r1 + " ερωτήσεις";
            } else {
                frm.childs[5].title = "Ποσοστό επιτυχίας : " + toround(obquiz.qright / obquiz.qtotal * 100) + "%"
            }
        }
    }

    btn3.onclick = function () {
        var frm = flist.getvisiblechild()
        var li = frm.childs[1]// 
        frm.myqob.checked = 2;/// wrong

        var res = li.checkchilds(frm.myqob.c)
        if (res) {
            frm.myqob.checked = 1; ///correct
        }

    }

    resetquiz(obquiz)
}







///// end quiz



/////////////////    sound 
var snd = new Audio("images/lala1.mp3");


function soundplay(aaudio, asource) {
    aaudio.src = asource
    aaudio.currentTime = 0;
    aaudio.play();

}



function soundpause(aaudio) {
    aaudio.pause();
    aaudio.currentTime = 0;

}


//// end sound 
var gx, gy, gw, gh, gdx, gdy;

var snds = ["1.mp3", "2.mp3", "3.mp3", "4.mp3", "5.mp3", "6.mp3"]
var sndtexts = ["140db ήχος αεροπλάνου", "100db ήχος από κουδούνι σχολείου",
    "85db ήχοι από δρόμους ταχείας κυκλοφορίας",
    "70db ήχοι από προαύλιο σχολείου",
    "40db ήχοι δάσους",
    "20db ψίθυροι"]
var forms = [];
var formsid = 1;
var imagenum = 8;
var mbuttons = [];
var mbuttonsid = 10;
var mbuttonst = ["Πίεση και Ένταση", "Σύγκριση ήχων", "Decibel", "Ήχοι", "Κουίζ"];
// y=A*sin(2*pi*f-x/l)

var fr = 0.33;
var A = 50;
var t = 0;
var pmin = 100;
var pdx = 5;
var L = 25;
var sb1;
var egky, egkx, diamx, diamy;
var defp = "Όταν μεταβάλλεται η πίεση του αέρα δημιουργείται ηχητικό κύμα."
var defi = "Ένταση  ήχου  είναι η  ενέργεια  που περνάει κάθε δευτερόλεπτο από την μονάδα εμβαδού."
var lb1, lb2;
var forms1l = [];
var ff3 = [];
var ff3id = 20;
var pick1 = [0, 68, 71, 74, 77, 80, 121];
var pick2 = ["Το αυτί δεν αντιλαμβάνεται ήχους όταν η μεταβολή πίεσης είναι μικρότερη από 20 microPa",
    "Το αυτί αντιλαμβάνεται ήχους όταν η μεταβολή πίεσης είναι μεγαλύτερη από 20 microPa",
    "Καλή κατάσταση",
    "Σχεδόν ανεκτή κατάσταση",
    "Θορυβώδης κατάσταση",
    "Πολύ Θορυβώδης κατάσταση",
    "Απαράδεκτη κατάσταση"]
var pick3=[rgb(232, 237, 233),rgb(166,255,166),rgb(125, 244, 255),rgb(40, 203, 224),rgb(255, 150, 140),rgb(255, 108, 94),rgb(250, 72, 55)]
        function showform(ni) {

            var i;
            for (i = 0; i < forms.length; i++) {
                forms[i].visible = i === ni
                
                
                mbuttons[i].backcolor = rgb(250, 250, 250)
                mbuttons[i].textcolor = "grey"
                if (i===ni && ni!==4){mbuttons[i].backcolor = rgb(250, 250, 250)
                mbuttons[i].textcolor = "blue"
                }
            }
        }

function create() {
    var imi;
    for (imi = 1; imi <= 17; imi++) {
        im.push(sm.createimage("images/" + imi + ".png"));
    }

    var i;
    gx = 8;
    gy = 8;
    gw = 170;
    gh = (720 - 6 * 8 - 48) / 5;
    gdy = gh + 8;
    for (i = 0; i < 5; i++) {
        mbuttons.push(form0.addbutton(i + mbuttonsid, mbuttonst[i], gx, gy + (i) * gdy, gw, gh))

    }
    gx = 188;
    gw = appw - 8 - 180 - 8;
    gh = 720 - 48 - 16;
    for (i = 0; i < 5; i++) {
        forms.push(form0.addform(i + formsid, "", gx, gy, gw, gh))
        forms[i].backcolor = "white"
    }

    //// form0 
    //
    egkx = 120;
    diamx = egkx;
    egky = 280;
    diamy = egky - 250;
    var f = forms[0].addform(0, "", 0, 0, 800, 500);
    sb1 = forms[0].addscrollbar(0, "A", diamx, 555, 500, 50)
    sb1.setvalues(0, 100, 0)
    f.backcolor = "white"
    f.addshape(0, "", egkx - 50, egky - 40, 40, 80, im[6])
    f.addshape(0, "", egkx + 100 * pdx, egky - 40, 40, 80, im[7])

    f.addshape(0, "", diamx - 50, diamy + 10, 40, 80, im[6])
    f.addshape(0, "", diamx + 100 * pdx + 5, diamy + 10, 35, 80, im[8])
    var f1 = f.addform(0, defi, diamx + 600, diamy + 6, 360, 100)
    f1.wrap = true;
    f1.backout(false)
    var f2 = f.addform(0, defp, egkx + 600, egky - 30, 360, 100)
    f2.backout(false)
    f2.wrap = true;
    var f3 = f.addform(0, defp, 716, 450, 320, 150)
    f3.backout(true, true);
    f3.backcolor = "beige"
    f3.wrap = true;
    f3.textcentered = false;
    f3.corner=4
    f.userdraw = function (ctx) {
        A = sb1.value / 2;
        sb1.valuedraw = false;
        for (i = 0; i < 100; i++) {

            var x = i * pdx;
            t = form0.gettime();
            //pressure egk
            var y = A * sin(2 * pi * fr * t - x / L)
            styles(ctx, "black", "red")
            f.drawpolar(egkx + x, egky, pdx - 2, 0)
            f.drawrect(egkx + x, egky - y, pdx - 1, 100 + y, 1)
            //// diam
            var cb = 155 - y
            var col = rgb(cb, cb, 255);
            styles(ctx, col)
            f.drawrect(diamx + x, diamy, pdx, 100, 2)

        }
        styles(ctx, "black", "red")
        var expn = sb1.value * 8 / sb1.max - 1;  // -1 to 7
        var v1 = 2 * Math.pow(10, expn);
        var st1 = v1;
        var st2;

        if (st1 < 1)
            st1 = todecimal(st1, 1);
        else
            st1 = toint(st1)


        var v2 = 1 / 400 * v1 * v1;
        var db0 = 10 * Math.log10(v2)
        var db = db0;
        if (db >= 0)
            db = toint(db);
        else
            db = todecimal(db, 1)
        if (st1 < 20)
            st2 = todecimal(v2, 4);
        else
            st2 = toint(v2)
        styles(ctx, "black")
        sb1.drawtext("Μεταβολή Πίεσης", 10, -80, 20, true)
        sb1.drawtext("Ένταση ήχου", 10, -50, 20, true)
        sb1.drawtext("Αριθμός decibel", 10, -20, 20, true)

        var sbs = 170;
        sb1.drawtext("= " + st1 + " microPa", sbs, -80, 20, true)
        sb1.drawtext("= " + st2 + " picoWatt / m²", sbs, -50, 20, true)
        sb1.drawtext("= " + db, sbs, -20, 20, true)

        f3.title = dbinfo(db0)
        f3.backcolor=pick(db0,pick1,pick3)
    }
    /// end forms[0]

    //forms[1]
    f = forms[1];
    var lbw = 220;
    lb1 = f.addlist(0, "", 100, 100, lbw, 440);
    lb1.addlistitems([1, 2, 3, 4, 5, 10, 100, 1000, 10000, 100000, 1000000])
    lb1.addlabel(0, "Ήχος 1", 0, -70, lbw, 30)
    lb1.addlabel(0, "Ένταση (picoWatt/m²)", 0, -40, lbw, 30)
    lb2 = f.addlist(0, "", 200 + lbw, 100, lbw, 440);
    lb1.selectitem(0)


    lb2.addlistitems([1, 2, 3, 4, 5, 10, 100, 1000, 10000, 100000, 1000000])
    lb2.selectitem(0)
    lb2.addlabel(0, "Ήχος 2", 0, -70, lbw, 30)
    lb2.addlabel(0, "Ένταση (picoWatt/m²)", 0, -40, lbw, 30)
    lb1.backcolor = "azure"
    lb2.backcolor = "azure"
    lb1.backout(true, true);
    lb2.backout(true, true);
    f.userdraw = function (ctx) {

        var db1, db2;
        var resar = lb1.getselectedchilds();
        var i1 = Number(resar[0].title)
        resar = lb2.getselectedchilds();
        var i2 = Number(resar[0].title)

        var imax = max(i1, i2);
        var imin = min(i1, i2)
        var stri, strloud;
        if (imax === imin)
            stri = "Οι δύο ήχοι έχουν την ίδια ένταση";
        else {

            stri = "Ο ένας ήχος έχει " + ifdecimal(imax / imin, 2) + " φορές μεγαλύτερη ένταση από τον άλλο"
        }

        var db0 = 10 * Math.log10(imax / imin);


        forms1l[1].title = stri;

        forms1l[0].title = "Aριθμός Decibel " + ifdecimal(db0, 3);

        var gain = Math.pow(2, db0 / 10);
        if (gain === 1)
            strloud = "To αυτί αντιλαμβάνεται ότι οι δύο ήχοι έχουν την ίδια ένταση";
        else {
            strloud = "To αυτί αντιλαμβάνεται ότι ο ένας ήχος είναι " + ifdecimal(gain, 2) + " φορές πιο δυνατός από τον άλλο"
        }

        forms1l[2].title = strloud;

    }
    /// labels
    for (i = 0; i < 3; i++) {

        forms1l.push(lb2.addlabel(0, "a a", 320, 0 + i * 98, 280, 90))
        forms1l[i].wrap = true;
        forms1l[i].backcolor = "beige"
        forms1l[i].backout(true, true);
        forms1l[i].corner = 4
    }

    //// forms [2] decibel

    f = forms[2];
    var f2l1 = f.addlabel(0, "Το decibel είναι μονάδα που χρησιμεύει στην σύγκριση των εντάσεων δύο ηχητικών κυμάτων. Παρατήρησε τον παρακάτω πίνακα.", 280, 10, 500, 50)
    f2l1.wrap = true;
    var ar1 = ["Ένταση  σε picoWatt/m²", 1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000, 1e10, 1e11, 1e12];
    var ar2 = ["decibel", 0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100, 110, 120];
    gx = 400;
    gy = 100;
    gw = 130;

    var f2l1 = f.addlabel(0, ar1[0], gx, gy + 15, 160, 60)
    f2l1.wrap = true;
    f2l1.backout(false, true)
    var f2l2 = f.addlabel(0, ar2[0], gx + 160, gy + 15, 80, 60)
    f2l2.wrap = true;
    f2l2.backout(false, true)
    f.userdraw = function (ctx) {
        gx = 400;
        gy = 100;
        gw = 130;
        styles(ctx, "black")

        for (i = 1; i < ar1.length; i++) {

            f.drawtext(ar1[i], gx + 78, gy + 70 + i * 30, 20)
            f.drawrect(gx, gy + 84 + (i - 1) * 30, 240, 30, 0)
            f.drawtext(ar2[i], gx + 200, gy + 70 + i * 30, 20)
        }

        f.drawrect(gx + 160, gy + 84, 0.01, 13 * 30, 0)
    }
    ///// form3;
    f = forms[3];
    gx = 262;
    gy = 8;
    for (i = 0; i < 6; i++) {
        ff3.push(f.addbutton(ff3id + i, "", gx, gy + i * 108, 160, 100, im[i]))
        var frm = ff3[i].addlabel(0, sndtexts[i], 160 + 32, 100 - 63, 200, 30);
        frm.textcentered = false
    }

    ///// quiz
    makequizform(form0, obquiz)
    obquiz.fparent.visible=!true;
    showform(4);
} /// end create
function dbinfo(db) {
    return pick(db,pick1, pick2)

}


sm.onclick = function (ob) {
    if (ob.id <= 0)
        return;
    soundpause(snd)
    var id;

    if (ob.id >= mbuttonsid && ob.id < mbuttonsid + forms.length) {
        showform(ob.id - mbuttonsid)

    }
    if (ob.id === mbuttonsid + forms.length - 1) {
        resetquiz(obquiz);
        obquiz.fparent.visible = true;

    }
    if (ob.id >= ff3id && ob.id <= ff3id + ff3.length) {
        id = ob.id - ff3id;
        soundplay(snd, "images/" + snds[id])

    }

}
form0.userdraw = function (ctx) {

}



function init() {


}
function imagesloaded() {

}
function bodyload() {
    create();
    init();

    gf.start();
}


//-------------------------------------  app var


//////////////////////      etc /////////////////////

var label2 = gui.addlabel(-4, appname, 0, 0, appw, 48);
label2.backcolor = rgb(250, 250, 250)

label2.textcentered = false; //
label2.addfs(8, 8, 32, 32);
var btnabout = label2.addbutton(-5, "", appw - 48, 0, 48, 48, sm.getimageres("about"));
btnabout.drawbackground = false;
btnabout.drawoutline = false;
var btnhelp = label2.addbutton(-6, "", appw - 100, 0, 48, 48, sm.getimageres("help"));
btnhelp.drawbackground = false;
btnhelp.drawoutline = false;


btnabout.onclick = function () {
    window.open('index_DS_II.html');
//formabout.visible = !false;
}
btnhelp.onclick = function () {
    formhelp.visible = !formhelp.visible; //false;

}



var fhw = 540;
var fhh = 90;
var formhelp = gui.addform(-7, "", 1280 - fhw, 76, fhw, fhh);
formhelp.shadow = true;
formhelp.texth = 20;
formhelp.visible = false;
formhelp.backcolor = rgb(255, 255, 204);

formhelp.userdraw = function (ctx) {
    wraptext(formhelp.ctx, helptext, formhelp.xg + 12, formhelp.yg + 32, formhelp.width - 12, 22);

}


//formhelp.center();

var bc1 = formhelp.addbutton(-8, "", formhelp.width - 56, 0, 48, 48, sm.getimageres("close"));
bc1.drawoutline = false;
bc1.drawoutline = false;
bc1.onclick = function () {
    formhelp.visible = false;
}

bc1.drawbackground = false;
bc1.drawoutline = false;







